#include <time.h>
#include <errno.h>
#include <math.h>
#include <stdio.h>
#include <conio.h>
#include <string.h>
#include "sd_main.hpp"
#include "memfunc.hpp"
#include "types.hpp"
#include "errorh.hpp"
#include "snd.hpp"
#include "sndwavst.hpp"
#include "rsc.hpp"
#include "rscdf.hpp"

char DelString [] =
	{
		0x8, 0x8, 0x8, 0x8, 0x8, 0x8, 0x8, 0x8, 0x8, 0x8,
		0x8, 0x8, 0x8, 0x8, 0x8, 0x8, 0x8, 0x8, 0x8, 0x8,
		0x8, 0x8, 0x8, 0x8, 0x8, 0x8, 0x8, 0x8, 0x8, 0x8,
		0x8, 0x8, 0x8, 0x8, 0x8, 0x8, 0x8, 0x8, 0x8, 0x8,
		0x8, 0x8, 0x8, 0x8, 0x8, 0x8, 0x8, 0x8, 0x8, 0x8,
		0x8, 0x8, 0x8, 0x8, 0x8, 0x8, 0x8, 0x8, 0x8, 0x8,
		0x8, 0x8, 0x8, 0x8, 0x8, 0x8, 0x8, 0x8, 0x8, 0x8,
		0x8, 0x8, 0x8, 0x8, 0x8, 0x8, 0x8, 0x8
	};

char FillString [] =
	{
		0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
		0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
		0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
		0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
		0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
		0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
		0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
		0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20
	};

SDWORD AuraPreset;
FLOATING AuraVolume;
FLOATING AuraDelay;
FLOATING AuraPanChange;
DWORD TotalLength;
DWORD ReadLength;

char msgNoMemory [] = "Not enough memory!";

TSNDWAVST_WAVSoundStream *InSoundStream;
TSNDWAVST_WAVSoundStream *OutSoundStream;
TRSCDF_ResourceDOSFile *InFile;
TRSC_ResourceHandle *InHandle;
TRSCDF_ResourceDOSFile *OutFile;
TRSC_ResourceHandle *OutHandle;
TSND_SampleParameters SampleParameters;

typedef struct TPreset
	{
		FLOATING LF1a;
		FLOATING LF1b;
		FLOATING LF1Vol;
		FLOATING LF2a;
		FLOATING LF2b;
		FLOATING LF2Vol;
		FLOATING LF3a;
		FLOATING LF3b;
		FLOATING LF3Vol;
		FLOATING RF1a;
		FLOATING RF1b;
		FLOATING RF1Vol;
		FLOATING RF2a;
		FLOATING RF2b;
		FLOATING RF2Vol;
		FLOATING RF3a;
		FLOATING RF3b;
		FLOATING RF3Vol;
	} TPreset;

static TPreset Presets [7] =
	{
		{
			16.0, 100.0, 0.2,
			100.0, 7000.0, 0.9,
			7000.0, 24000.0, 0.2,
			16.0, 100.0, 0.2,
			100.0, 7000.0, 0.9,
			7000.0, 24000.0, 0.2,
		},
		{
			16.0, 200.0, 0.1,
			200.0, 8000.0, 1.3,
			8000.0, 24000.0, 0.1,
			16.0, 200.0, 0.1,
			200.0, 8000.0, 1.3,
			8000.0, 24000.0, 0.1,
		},
		{
			16.0, 100.0, 0.3,
			100.0, 7000.0, 0.6,
			7000.0, 24000.0, 0.9,
			16.0, 300.0, 0.3,
			300.0, 9000.0, 0.6,
			9000.0, 24000.0, 0.9,
		},
		{
			16.0, 200.0, 1.4,
			200.0, 1000.0, 1.2,
			1000.0, 24000.0, 0.2,
			16.0, 200.0, 1.4,
			200.0, 1000.0, 1.2,
			1000.0, 24000.0, 0.2,
		},
		{
			16.0, 100.0, 2.0,
			100.0, 500.0, 1.5,
			500.0, 24000.0, 0.3,
			16.0, 150.0, 2.0,
			150.0, 500.0, 1.5,
			500.0, 24000.0, 0.3,
		},
		{
			16.0, 100.0, 1.3,
			100.0, 5000.0, 0.6,
			5000.0, 24000.0, 1.2,
			16.0, 150.0, 1.3,
			150.0, 7000.0, 0.6,
			7000.0, 24000.0, 1.2,
		},
		{
			7000.0, 15000.0, 0.6,
			15000.0, 20000.0, 0.9,
			20000.0, 24000.0, 1.2,
			7000.0, 15000.0, 0.6,
			15000.0, 20000.0, 0.9,
			20000.0, 24000.0, 1.2,
		}
	};

/* ------------------------------------------------------------------------ */

void WAVOpen (char *FileName, char *OutFileName)
	{
		InFile = new TRSCDF_ResourceDOSFile (FileName, RSCDF_OpenModeReadOnly);

		if (EH_ErrorReportResult != 0)
			{
				EH_ErrorExit ("Error opening [infile]!");
			};

		RSC_ResourceInstall ("in", InFile);

		if (EH_ErrorReportResult != 0)
			{
				EH_ErrorExit ("Error installing inresource!");
			};

		InHandle = new TRSC_ResourceHandle ("in", RSC_flgResourceAccessModeRead);

		if (EH_ErrorReportResult != 0)
			{
				EH_ErrorExit ("Error creating inhandle!");
			};

		InSoundStream = new TSNDWAVST_WAVSoundStream ();

		if (EH_ErrorReportResult != 0)
			{
				EH_ErrorExit ("Error creating sound stream!");
			};

		InSoundStream -> ReadInitialize (InHandle, SampleParameters);

		if (EH_ErrorReportResult != 0)
			{
				EH_ErrorExit ("Error initializing sound stream read!");
			};

		InSoundStream -> SampleLengthGet (&ReadLength);

		OutFile = new TRSCDF_ResourceDOSFile (OutFileName, RSCDF_OpenModeCreate);

		if (EH_ErrorReportResult != 0)
			{
				EH_ErrorExit ("Error creating [outfile]!");
			};

		RSC_ResourceInstall ("out", OutFile);

		if (EH_ErrorReportResult != 0)
			{
				EH_ErrorExit ("Error installing outresource!");
			};

		OutHandle = new TRSC_ResourceHandle ("out", RSC_flgResourceAccessModeWrite);

		if (EH_ErrorReportResult != 0)
			{
				EH_ErrorExit ("Error creating outhandle!");
			};

		OutSoundStream = new TSNDWAVST_WAVSoundStream ();

		if (EH_ErrorReportResult != 0)
			{
				EH_ErrorExit ("Error creating sound stream!");
			};

		OutSoundStream -> WriteInitialize (OutHandle, SampleParameters);

		if (EH_ErrorReportResult != 0)
			{
				EH_ErrorExit ("Error initializing sound stream write!");
			};
	};

/* ------------------------------------------------------------------------ */

void WAVWrite (void)
	{
		InSoundStream -> Deinitialize ();
		OutSoundStream -> Deinitialize ();

		delete OutSoundStream;
		delete OutHandle;
		RSC_ResourceDeinstall (OutFile);
		delete OutFile;

		delete InSoundStream;
		delete InHandle;
		RSC_ResourceDeinstall (InFile);
		delete InFile;
	};

/* ------------------------------------------------------------------------ */
/* TBandwidthFilter ------------------------------------------------------- */
/* ------------------------------------------------------------------------ */

class TBandwidthFilter : public TObject
	{
		protected:
			DWORD Frequency;
			SDWORD FilterBufferSize;
			SDWORD FilterBufferHead;
			FLOATING *FilterBuffer;
			SDWORD FilterFrequencyLow;
			SDWORD FilterFrequencyHigh;
			FLOATING FilterAccumulatorLow;
			FLOATING FilterAccumulatorHigh;

			inline FLOATING FilterBufferSampleGet (DWORD Index)
				{
					DWORD RealIndex = Index;

					if (RealIndex >= FilterBufferSize)
						RealIndex -= FilterBufferSize;

					return *(FilterBuffer + RealIndex);
				};

		public:
			TBandwidthFilter (FLOATING FreqLow, FLOATING FreqHigh, DWORD aFrequency);
			~TBandwidthFilter (void);

			inline FLOATING FilterGet (FLOATING Sample)
				{
					FilterBufferHead--;

					if (FilterBufferHead < 0)
						FilterBufferHead = FilterBufferSize - 1;

					*(FilterBuffer + FilterBufferHead) = Sample;

					FilterAccumulatorLow -= FilterBufferSampleGet (FilterBufferHead + FilterFrequencyLow);
					FilterAccumulatorLow += Sample;
					FilterAccumulatorHigh -= FilterBufferSampleGet (FilterBufferHead + FilterFrequencyHigh);
					FilterAccumulatorHigh += Sample;

					return -(FilterAccumulatorLow / (FilterFrequencyLow + 1) - FilterAccumulatorHigh / (FilterFrequencyHigh + 1));
				};

			void BandwidthSet (FLOATING FreqLow, FLOATING FreqHigh);
	};

/* ------------------------------------------------------------------------ */

TBandwidthFilter::TBandwidthFilter (FLOATING FreqLow, FLOATING FreqHigh, DWORD aFrequency)
	{
		Frequency = aFrequency;
		FilterBufferSize = Frequency / 14;
		FilterBufferHead = 0;
		FilterBuffer = (FLOATING *) MF_MemoryAllocateNoCheck (FilterBufferSize * sizeof (FLOATING));

		if (EH_ErrorReportResult != 0)
			{
				return;
			};

		for (DWORD i = 0; i < FilterBufferSize; i++)
			*(FilterBuffer + i) = 0.0;

		BandwidthSet (FreqLow, FreqHigh);
	};

/* ------------------------------------------------------------------------ */

TBandwidthFilter::~TBandwidthFilter (void)
	{
		delete FilterBuffer;
	};

/* ------------------------------------------------------------------------ */

void TBandwidthFilter::BandwidthSet (FLOATING FreqLow, FLOATING FreqHigh)
	{
		FreqLow = max (16.0, FreqLow);
		FreqHigh = min (Frequency / 2, FreqHigh);

		FilterFrequencyLow = (SDWORD) ((FLOATING) Frequency / FreqLow);
		FilterFrequencyHigh = (SDWORD) ((FLOATING) Frequency / FreqHigh);
		FilterAccumulatorLow = 0.0;
		FilterAccumulatorHigh = 0.0;
	};

/* ------------------------------------------------------------------------ */
/* TDCOffsetEliminator ---------------------------------------------------- */
/* ------------------------------------------------------------------------ */

const DCOffsetWindowSize = 512;

class TDCOffsetEliminator : public TObject
	{
		protected:
			FLOATING DCOffset;
			FLOATING DCOffsetWindow [DCOffsetWindowSize];
			SDWORD DCOffsetWindowHead;

		public:
			TDCOffsetEliminator (void);

			inline FLOATING DCOffsetProcess (FLOATING Output)
				{
					DCOffset += Output;
					DCOffsetWindow [DCOffsetWindowHead] = Output;

					DCOffsetWindowHead--;

					if (DCOffsetWindowHead < 0)
						DCOffsetWindowHead = DCOffsetWindowSize - 1;

					DCOffset -= DCOffsetWindow [DCOffsetWindowHead];
					Output -= DCOffset / DCOffsetWindowSize;

					return Output;
				};
	};

/* ------------------------------------------------------------------------ */

TDCOffsetEliminator::TDCOffsetEliminator (void)
	{
		DCOffset = 0.0;
		DCOffsetWindowHead = 0;

		for (DWORD i = 0; i < DCOffsetWindowSize; i++)
			DCOffsetWindow [i] = 0.0;
	};

/* ------------------------------------------------------------------------ */
/* TDelay ----------------------------------------------------------------- */
/* ------------------------------------------------------------------------ */

class TDelay : public TObject
	{
		protected:
			FLOATING DelayAmount;
			DWORD SampleFrequency;
			FLOATING *DelayBuffer;
			DWORD DelayBufferSize;
			SDWORD DelayBufferPos;

		public:
			inline TDelay (FLOATING aDelayAmount, DWORD aSampleFrequency)
				{
					DelayAmount = aDelayAmount;
					SampleFrequency = aSampleFrequency;
					DelayBufferPos = 0;
					DelayBufferSize = (DWORD) ((FLOATING) aSampleFrequency * aDelayAmount);
					DelayBuffer = (FLOATING *) MF_MemoryAllocateNoCheck (DelayBufferSize * sizeof (FLOATING));

					if (EH_ErrorReportResult != 0)
						{
							return;
						};

					for (DWORD i = 0; i < DelayBufferSize; i++)
						*(DelayBuffer + i) = 0.0;
				};

			inline ~TDelay (void)
				{
					delete DelayBuffer;
				};

			inline FLOATING DelayGet (FLOATING Sample)
				{
					FLOATING NewSample = *(DelayBuffer + DelayBufferPos);

					*(DelayBuffer + DelayBufferPos) = Sample;

					DelayBufferPos--;

					if (DelayBufferPos < 0)
						{
							DelayBufferPos = DelayBufferSize - 1;
						};

					return NewSample;
				};
	};

/* ------------------------------------------------------------------------ */
/* TBandwidthFilterAmp ------------------------------------------------------------- */
/* ------------------------------------------------------------------------ */

class TBandwidthFilterAmp : public TObject
	{
		protected:
			FLOATING Volume;
			FLOATING SampleFrequency;

			TDCOffsetEliminator *DCOffsetEliminator;
			TBandwidthFilter *BandwidthFilter;

		public:
			TBandwidthFilterAmp (FLOATING FreqLow, FLOATING FreqHigh, FLOATING Vol, DWORD SampleFreq);
			~TBandwidthFilterAmp (void);

			inline FLOATING SampleProcess (FLOATING Sample)
				{
					return DCOffsetEliminator -> DCOffsetProcess (BandwidthFilter -> FilterGet (Sample)) * Volume;
				};
	};

/* ------------------------------------------------------------------------ */

TBandwidthFilterAmp::TBandwidthFilterAmp (FLOATING FreqLow, FLOATING FreqHigh, FLOATING Vol, DWORD SampleFreq)
	{
		Volume = Vol;
		SampleFrequency = SampleFreq;

		DCOffsetEliminator = new TDCOffsetEliminator ();

		if (EH_ErrorReportResult != 0)
			return;

		BandwidthFilter = new TBandwidthFilter (FreqLow, FreqHigh, SampleFreq);

		if (EH_ErrorReportResult != 0)
			return;
	};

/* ------------------------------------------------------------------------ */

TBandwidthFilterAmp::~TBandwidthFilterAmp (void)
	{
		delete BandwidthFilter;
		delete DCOffsetEliminator;
	};

/* ------------------------------------------------------------------------ */
/* TAuraliser ------------------------------------------------------------- */
/* ------------------------------------------------------------------------ */

class TAuraliser : public TObject
	{
		protected:
			TBandwidthFilterAmp *AuralisersL [3];
			TBandwidthFilterAmp *AuralisersR [3];
			TDelay *DelayL;
			TDelay *DelayR;
			FLOATING VolLL;
			FLOATING VolLR;
			FLOATING VolRL;
			FLOATING VolRR;
			FLOATING Volume;
			FLOATING VolumeDry;

		public:
			TAuraliser (DWORD PresetNumber, FLOATING aDelay, DWORD SampleFrequency, FLOATING PanChange, FLOATING Vol, FLOATING DryVol);
			~TAuraliser ();

			inline void ProcessSample (FLOATING SampleL, FLOATING SampleR, FLOATING &aOutL, FLOATING &aOutR)
				{
					FLOATING OutL = 0.0;
					FLOATING OutR = 0.0;

					for (DWORD i = 0; i < 3; i++)
						{
							FLOATING NewL = AuralisersL [i] -> SampleProcess (SampleL);
							FLOATING NewR = AuralisersR [i] -> SampleProcess (SampleR);

							OutL += NewL * VolLL + NewR * VolRL;
							OutR += NewR * VolRR + NewL * VolLR;
						};

					aOutL = SampleL * VolumeDry + DelayL -> DelayGet (OutL) * Volume;
					aOutR = SampleR * VolumeDry + -(DelayR -> DelayGet (OutR) * Volume);
				};
	};

/* ------------------------------------------------------------------------ */

TAuraliser::TAuraliser (DWORD PresetNumber, FLOATING aDelay, DWORD SampleFrequency, FLOATING PanChange, FLOATING Vol, FLOATING DryVol) : TObject ()
	{
		PanChange = max (0.0, min (PanChange, 1.0));

		VolLL = 0.0 + PanChange;
		VolLR = 1.0 - PanChange;
		VolRL = 1.0 - PanChange;
		VolRR = 0.0 + PanChange;
		Volume = Vol;
		VolumeDry = DryVol;

		DelayL = new TDelay (aDelay, SampleFrequency);

		if (EH_ErrorReportResult != 0)
			return;

		DelayR = new TDelay (aDelay, SampleFrequency);

		if (EH_ErrorReportResult != 0)
			return;

		AuralisersL [0] = new TBandwidthFilterAmp (Presets [PresetNumber].LF1a, Presets [PresetNumber].LF1b, Presets [PresetNumber].LF1Vol, SampleFrequency);
		AuralisersL [1] = new TBandwidthFilterAmp (Presets [PresetNumber].LF2a, Presets [PresetNumber].LF2b, Presets [PresetNumber].LF2Vol, SampleFrequency);
		AuralisersL [2] = new TBandwidthFilterAmp (Presets [PresetNumber].LF3a, Presets [PresetNumber].LF3b, Presets [PresetNumber].LF3Vol, SampleFrequency);

		AuralisersR [0] = new TBandwidthFilterAmp (Presets [PresetNumber].RF1a, Presets [PresetNumber].RF1b, Presets [PresetNumber].RF1Vol, SampleFrequency);
		AuralisersR [1] = new TBandwidthFilterAmp (Presets [PresetNumber].RF2a, Presets [PresetNumber].RF2b, Presets [PresetNumber].RF2Vol, SampleFrequency);
		AuralisersR [2] = new TBandwidthFilterAmp (Presets [PresetNumber].RF3a, Presets [PresetNumber].RF3b, Presets [PresetNumber].RF3Vol, SampleFrequency);

		if (EH_ErrorReportResult != 0)
			return;
	};

/* ------------------------------------------------------------------------ */

TAuraliser::~TAuraliser (void)
	{
	};

/* ------------------------------------------------------------------------ */
/* ------------------------------------------------------------------------ */
/* ------------------------------------------------------------------------ */

TAuraliser *Auraliser;
DWORD ClipCount;

inline SWORD DoClip (FLOATING Sample)
	{
		Sample *= 32768.0;

		SDWORD OutSample = (SDWORD) Sample;

		if (OutSample > 32767)
			{
				ClipCount++;
				return (SWORD) 32767;
			}
		else
			if (OutSample < -32768)
				{
					ClipCount++;
					return (SWORD) -32768;
				}
			else
				return (SWORD) OutSample;
	};

void WAVAuraliseBlock (TSND_Sample *InSample, TSND_Sample *OutSample)
	{
		FLOATING CurrentSample1;
		FLOATING CurrentSample2;
		FLOATING NewSampleL;
		FLOATING NewSampleR;
		DWORD i;

		if ((SampleParameters.SampleDepth == 16) && (SampleParameters.SampleChannelCount == 2))
			{
				for (i = 0; i < InSample -> SampleLength; i++)
					{
						CurrentSample1 = (FLOATING) (*(SWORD *) ((DWORD) InSample -> Buffer + (i << 2))) / (FLOATING) 32768.0;
						CurrentSample2 = (FLOATING) (*(SWORD *) ((DWORD) InSample -> Buffer + (i << 2) + 2)) / (FLOATING) 32768.0;
						Auraliser -> ProcessSample (CurrentSample1, CurrentSample2, NewSampleL, NewSampleR);

						*(SWORD *) ((DWORD) OutSample -> Buffer + (i << 2)) = DoClip (NewSampleL);
						*(SWORD *) ((DWORD) OutSample -> Buffer + (i << 2) + 2) = DoClip (NewSampleR);
					};
			};
	};

/* ------------------------------------------------------------------------ */

void WAVAuralise (void)
	{
		ClipCount = 0;

		Auraliser = new TAuraliser (AuraPreset, AuraDelay, SampleParameters.SampleFrequency, AuraPanChange, AuraVolume, 1.0);

		if (EH_ErrorReportResult != 0)
			EH_ErrorExit (msgNoMemory);

		TotalLength = ReadLength;

		DWORD Clk1 = clock ();

		DWORD LeftToProcess = TotalLength;
		DWORD BlockSize;
		DWORD ReadLeft;
		TSND_Sample *TempSample;

		while (LeftToProcess > 0)
			{
				if (kbhit ())
					{
						int k = getch ();

						if (k == 0)
							{
								k = getch ();
							}
						else
							if (k == 27)
								{
									printf ("%s%s%sCancelled!\n", DelString, FillString, DelString);
									EH_ErrorExit (NULL);
								};
					};

				printf ("%s%s%s%6.2f%% complete...", DelString, FillString, DelString, 100.0 - ((FLOATING) LeftToProcess / (FLOATING) TotalLength) * 100.0);
				fflush (stdout);

				InSoundStream -> SampleLengthLeftGet (&ReadLeft);

				if (ReadLeft == 0)
					{
						BlockSize = min (0x4000, LeftToProcess);

						TempSample = new TSND_Sample ();

						TempSample -> Parameters = SampleParameters;
						TempSample -> SampleLength = BlockSize;
						TempSample -> Buffer = MF_MemoryAllocate (BlockSize * SampleParameters.SampleSize);
						memset (TempSample -> Buffer, 0, BlockSize * SampleParameters.SampleSize);
					}
				else
					{
						BlockSize = min (0x4000, ReadLeft);
						TempSample = InSoundStream -> SampleBlockRead (BlockSize);

						if (EH_ErrorReportResult != 0)
							{
								EH_ErrorExit ("Error reading infile!");
							};
					};

				WAVAuraliseBlock (TempSample, TempSample);

				OutSoundStream -> SampleBlockWrite (TempSample);

				if (EH_ErrorReportResult != 0)
					{
						int k = getch ();
						EH_ErrorExit ("Error writing infile!");
					};

				delete TempSample;
				LeftToProcess -= BlockSize;
			};

		FLOATING Clk2 = ((FLOATING) clock () - (FLOATING) Clk1) / CLOCKS_PER_SEC;
		FLOATING Speed;

		if (Clk2 != 0.0)
			{
				Speed = (FLOATING) (TotalLength * SampleParameters.SampleSize) / Clk2 / 1024;
			}
		else
			{
				Speed = 9999.99;
			};

		printf ("%s%s%sProcessed in %4.2f seconds (at %4.2f kB/sec). Samples clipped: %u\n", DelString, FillString, DelString, Clk2, Speed, ClipCount);
	};

/* ------------------------------------------------------------------------ */

void main (int argc, char *argv [])
	{
		printf ("\n\nWAV Auraliser v1.0 (c) 1998 Seaber Designs\n"
			"Written by Aleksey V. Vaneev\n"
			"Bandwidth Filter (c) Rick Murray\n\n");

		if (argc < 7)
			{
				printf ("Usage: RAWAURAL.EXE <ifile> <ofile> <preset> <delay> <svol> <panch>\n\n"
					"Where <ifile> - input stereo 16bit wavfile\n"
					"      <ofile> - output file\n"
					"      <preset> - preset number [0; 6]\n"
					"      <delay> - surround delay in ms (affects surround depth) [5.0; 100.0]\n"
					"      <svol> - surround volume (affects surround intensity) [0.0; 10.0]\n"
					"      <panch> - surround pan change (slightly affects sound) [0.0; 1.0]\n\n");

				return;
			};

		errno = EZERO;
		AuraPreset = atol (argv [3]);

		if ((AuraPreset > 6) || (AuraPreset < 0) || (errno != EZERO))
			{
				printf ("Specified <preset> is invalid!\nMust be in [0; 6]\n");
				return;
			};

		errno = EZERO;
		AuraDelay = atof (argv [4]);

		if ((AuraDelay > 100.0) || (AuraDelay < 5.0) || (errno != EZERO))
			{
				printf ("Specified <delay> is invalid!\nMust be in [5.0; 100.0]\n");
				return;
			};

		AuraDelay /= 1000.0;

		errno = EZERO;
		AuraVolume = atof (argv [5]);

		if ((AuraVolume > 10.0) || (AuraVolume < 0.0) || (errno != EZERO))
			{
				printf ("Specified <svol> is invalid!\nMust be in [0.0; 10.0]\n");
				return;
			};

		errno = EZERO;
		AuraPanChange = atof (argv [6]);

		if ((AuraPanChange > 1.0) || (AuraPanChange < 0.0) || (errno != EZERO))
			{
				printf ("Specified <panch> is invalid!\nMust be in [0.0; 1.0]\n");
				return;
			};

		WAVOpen (argv [1], argv [2]);
		WAVAuralise ();
		WAVWrite ();
	};
